//-----------------------------------------
// LScript Generic template
//

@version 2.2
@warnings
@script generic
@name Joint Setup
// global values go here
myversion=1.0;
    mylock;
    myhide;
    mylkH;
    mylkP;
    mylkB;
    myHcon;
    myPcon;
    myBcon;

generic
{
    mylock=recall("MGJointSetupmylock",3);
    myhide=recall("MGJointSetupmyhide",6);
    mylkH=recall("MGJointSetupmylkH",3);
    mylkP=recall("MGJointSetupmylkP",3);
    mylkB=recall("MGJointSetupmylkB",3);
    myHcon=recall("MGJointSetupmyHcon",5);
    myPcon=recall("MGJointSetupmyPcon",5);
    myBcon=recall("MGJointSetupmyBcon",3);
    // perform all processing here

    reqbegin("Joint Setup by Mike Green Version:"+myversion);

    b0 = ctlchoice("Lock from selection",mylock,@"Lock","Unlock","No Change"@);
    b1 = ctlchoice("Hide Joint         ",myhide,@"Hide","Box","Front","Shaded","Text","No Change"@);
    b2 = ctlchoice("Lock H Rotation    ",mylkH,@"Yes","No","No Change"@);
    b3 = ctlchoice("Lock P Rotation    ",mylkP,@"Yes","No","No Change"@);
    b4 = ctlchoice("Lock B Rotation    ",mylkB,@"Yes","No","No Change"@);
    c1 = ctlchoice("H Controller       ",myHcon,@"Key","Target","Path","IK","No change"@);
    c2 = ctlchoice("P Controller       ",myPcon,@"Key","Target","Path","IK","No change"@);
    c3 = ctlchoice("B Controller       ",myBcon,@"Key","IK","No change"@);
    t1 = ctltext("Contact:","Dodgy@shortbutpurple.fsnet.co.uk");
    
    ctlposition(b0,10,10,350,20);
    ctlposition(b1,10,35,350,20);
    ctlposition(b2,10,60,350,20);
    ctlposition(b3,10,85,350,20);
    ctlposition(b4,10,110,350,20);
    ctlposition(c1,10,135,350,20);
    ctlposition(c2,10,160,350,20);
    ctlposition(c3,10,185,350,20);
    ctlposition(t1,10,210);


    return if !reqpost();

    mylock=getvalue(b0);
    myhide=getvalue(b1);
    mylkH=getvalue(b2);
    mylkP=getvalue(b3);
    mylkB=getvalue(b4);
    myHcon=getvalue(c1);
    myPcon=getvalue(c2);
    myBcon=getvalue(c3);

    store("MGJointSetupmylock",mylock);
    store("MGJointSetupmyhide",myhide);
    store("MGJointSetupmylkH",mylkH);
    store("MGJointSetupmylkP",mylkP);
    store("MGJointSetupmylkB",mylkB);
    store("MGJointSetupmyHcon",myHcon);
    store("MGJointSetupmyPcon",myPcon);
    store("MGJointSetupmyBcon",myBcon);
    // get requester control values here
    
    reqend();

    myselected=Scene().getSelect();
    if(!myselected)
    error("Please select some items");
//debug();
    mycurrent=myselected[1];

//==============================================================    
// Mesh type:
    if (mycurrent.genus==MESH)
    {
// do multiple object commands (controller) here:

        controllers();
  
// do individual object commands(lock/visible/enableXH) here:
        RotateTool();
        for(i=1;i<=myselected.size();i++)
        {
            mycurrent=myselected[i];

            SelectItem(myselected[i].id);

            axislocks(mycurrent);

            lockitem(mycurrent);

            switch(myhide)
            {
                case 1:
                    ItemVisibility(1);
                    break;
                case 2:
                    ItemVisibility(2);
                    break;
                case 3:
                    ItemVisibility(4);
                    break;
                case 4:
                    ItemVisibility(5);
                    break;
                case 5:
                    ItemVisibility(6);
                    break;
                default:
                    break;
            }
        }
    }    

//==============================================================    
// any other type:

    else
    {
// do multiple object commands (controller) here:

        controllers();
  
// do individual object commands(lock/visible/enableXH) here:
        RotateTool();
        for(i=1;i<=myselected.size();i++)
        {
            mycurrent=myselected[i];

            SelectItem(myselected[i].id);

            axislocks(mycurrent);

            lockitem(mycurrent);

            switch(myhide)
            {
                case 1:
                    ItemVisibility(1);
                    break;
                default:
                    ItemVisibility(2);
                    break;
            }
        }
    }
    selectitems(myselected);
//================================================================    
}

selectitems:myselected
{
    if(!myselected)
        return;
    SelectItem(myselected[1].id);
    for(i=2;i<=myselected.size();i++)
    {
        AddToSelection(myselected[i].id);
    }
    
}

lockitem:mycurrent
{
//debug();
            switch(mylock)
            {
                case 1:
                    if(!mycurrent.locked)
                        ItemLock(true);
                    break;
                case 2:
                    if(mycurrent.locked)
                        ItemLock(false);
                    break;
                default:
                    break;
            }
}
controllers
{
        if(myHcon!=5)
            HController(myHcon);
        if(myPcon!=5)
            PController(myPcon);
        if(myBcon==1)
            BController(1);
        else if(myBcon==2)
            BController(4);
}

axislocks:mycurrent
{
//debug();
            myaxislock[1]=mycurrent.axislocks[4];
            myaxislock[2]=mycurrent.axislocks[5];
            myaxislock[3]=mycurrent.axislocks[6];

            switch(mylkH)
            {
                case 1:
                    if(!myaxislock[1])
                        EnableXH();
                    break;
                case 2:
                    if(myaxislock[1])
                        EnableXH();
                    break;
                default:
                    break;
            }

            switch(mylkP)
            {
                case 1:
                    if(!myaxislock[2])
                        EnableYP();
                    break;
                case 2:
                    if(myaxislock[2])
                        EnableYP();
                    break;
                default:
                    break;
            }

            switch(mylkB)
            {
                case 1:
                    if(!myaxislock[3])
                        EnableZB();
                    break;
                case 2:
                    if(myaxislock[3])
                        EnableZB();
                    break;
                default:
                    break;
            }
    
}


